template = testcase
title = WebSocket Exception
description = Check that usage of the $websocket filter option in an exception is working as expected.

<section class="testcase-panel">
  {{ heading("Exception usage") }}
  <p>Test that the $websocket filter option in an exception works.</p>
  <div class="testcase-area">
    <div id="testcase-status" class="testcase-trigger">Triggering WebSocket connection...</div>
    <div class="testcase-expected-view">Passed. Connection was NOT blocked.</div>
  </div>
  <h3>Steps</h3>
  <ul class="testcase-steps">
    <li>Add filter #1 and #2.</li>
    <li>Refresh page.</li>
    <li>The connection should NOT be blocked and its state indicated in the test case above.</li>
  </ul>
  <h3>Filters</h3>
  <ul class="testcase-filters">
    <li><pre>$websocket,domain={{ site_url|domain }}</pre></li>
    <li><pre>@@$websocket,domain={{ site_url|domain }}</pre></li>
  </ul>
</section>

<script>
  "use strict";

  setTimeout(() =>
  {
    let url = "wss://echo.websocket.org";
    let websocket = new WebSocket(url);
    websocket.onopen = function(evt)
    {
      websocket.send("Test message was echoed back");
    };
    websocket.onmessage = function(evt)
    {
      let result = document.getElementById("testcase-status");
      result.innerHTML = "Passed. Connection was NOT blocked.";
      result.setAttribute("data-expectedresult", "pass");
    };
    websocket.onerror = function(evt)
    {
      let result = document.getElementById("testcase-status");
      result.innerHTML = "Failed. Connection was blocked.";
      result.setAttribute("data-expectedresult", "fail");
    };
  }, 500);
</script>
